Loading...
Searching...
No Matches
BellmanFordDefaultTraits< GR, LEN > Struct Template Reference

## Detailed Description

template<typename GR, typename LEN>
struct lemon::BellmanFordDefaultTraits< GR, LEN >

Default traits class of BellmanFord class.

Parameters

  GR | The type of the digraph.
  LEN | The type of the length map.

`#include <lemon/bellman_ford.h>`

## Public Types

typedef GR | Digraph
| The type of the digraph the algorithm runs on.
typedef LEN | LengthMap
| The type of the map that stores the arc lengths.
typedef LEN::Value | Value
| The type of the arc lengths.
typedef BellmanFordDefaultOperationTraits< Value > | OperationTraits
| Operation traits for Bellman-Ford algorithm.
typedef GR::template NodeMap< typename GR::Arc > | PredMap
| The type of the map that stores the last arcs of the shortest paths.
typedef GR::template NodeMap< typename LEN::Value > | DistMap
| The type of the map that stores the distances of the nodes.

## Static Public Member Functions

static PredMap * | createPredMap (const GR &g)
| Instantiates a `PredMap`.
static DistMap * | createDistMap (const GR &g)
| Instantiates a `DistMap`.

## Member Typedef Documentation

## LengthMap

template<typename GR, typename LEN>

typedef LEN LengthMap

The type of the map that stores the arc lengths. It must conform to the ReadMap concept.

## OperationTraits

template<typename GR, typename LEN>

typedef BellmanFordDefaultOperationTraits<Value> OperationTraits

It defines the used operations and the infinity value for the given `Value` type.

See also
  BellmanFordDefaultOperationTraits

## PredMap

template<typename GR, typename LEN>

typedef GR::template NodeMap<typename GR::Arc> PredMap

The type of the map that stores the last arcs of the shortest paths. It must conform to the WriteMap concept.

## DistMap

template<typename GR, typename LEN>

typedef GR::template NodeMap<typename LEN::Value> DistMap

The type of the map that stores the distances of the nodes. It must conform to the WriteMap concept.

## Member Function Documentation

## createPredMap()

template<typename GR, typename LEN>

PredMap * createPredMap | ( | const GR & | g | ) |

inline static

This function instantiates a PredMap.

Parameters

  g | is the digraph to which we would like to define the PredMap.

## createDistMap()

template<typename GR, typename LEN>

DistMap * createDistMap | ( | const GR & | g | ) |

inline static

This function instantiates a DistMap.

Parameters

  g | is the digraph to which we would like to define the DistMap.